'Speichert alle Einstellungen des Programms und serialisiert sie als Xml-Dokument
<Serializable()> Public Class clsSettings
    Public Enum Periode
        Nie
        Stndlich
        Tglich
        Wchentlich
        Monatlich
        Jhrlich
    End Enum

#Region "Standardwerte"
    ' Laufwerk:
    Private Const def_Geschwindigkeit As Integer = 99
    Private Const def_BufferUnderrunSchutz As Boolean = True
    Private Const def_AbfrageVorBrennen As Boolean = True
    Private Const def_CDRWAutomatischLschen As Boolean = False
    Private Const def_CdName As String = "Backup"
    Private Const def_DatumHinzufgen As Boolean = True
    Private Const def_SchnellLschung As Boolean = True
    ' Zeitplan:
    Private Const def_TermineWahrnehmen As Boolean = True
    ' Einstellungen:
    Private Const def_LogSpeichern As Integer = 7
    Private Const def_LogEwig As Boolean = False
#End Region

#Region "Einstellungen"
    ' Laufwerk:
    Public Laufwerk As Char
    Public Geschwindigkeit As Integer
    Public BufferUnderrunSchutz As Boolean
    Public AbfrageVorBrennen As Boolean
    Public CDRWAutomatischLschen As Boolean
    Public CdName As String
    Public DatumHinzufgen As Boolean
    Public SchnellLschung As Boolean
    ' Zeitplan:
    Public Termine() As Date
    Public Wiederholen() As Periode
    Public TermineWahrnehmen As Boolean
    ' Verzeichnisse
    Public Verzeichnisse() As String
    ' Einstellungen:
    Public LogSpeichern As Integer
    Public LogEwig As Boolean
#End Region

#Region "Lese/Schreibe Autostart"
    Friend Property Autostart() As Boolean 'Property, da in Registry gespeichert wird und von da gelesen/nach da geschrieben wird
        Get
            Try
                Dim reg As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software", False)
                Dim Werte() As String
                reg = reg.OpenSubKey("Microsoft", False)
                reg = reg.OpenSubKey("Windows", False)
                reg = reg.OpenSubKey("CurrentVersion", False)
                reg = reg.OpenSubKey("Run", False)
                Werte = reg.GetValueNames
                For Each Str As String In Werte
                    If Str = "ABS" Then Return True
                Next
            Catch ex As Exception
                MsgBox("Fehler beim Lesen der Registry" & vbCrLf & vbCrLf & ex.Message, MsgBoxStyle.Critical)
                Return False
            End Try
        End Get
        Set(ByVal Value As Boolean)
            Try
                Dim reg As Microsoft.Win32.RegistryKey = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software", True)
                reg = reg.OpenSubKey("Microsoft", True)
                reg = reg.OpenSubKey("Windows", True)
                reg = reg.OpenSubKey("CurrentVersion", True)
                reg = reg.OpenSubKey("Run", True)
                If Value = True Then
                    reg.SetValue("ABS", Application.ExecutablePath)
                Else
                    reg.DeleteValue("ABS", False)
                End If
            Catch ex As Exception
                MsgBox("Fehler beim Schreiben in die Registry" & vbCrLf & vbCrLf & ex.Message, MsgBoxStyle.Critical)
            End Try
        End Set
    End Property
#End Region

#Region "Einstellungen holen/speichern"
    'Liest Einstellungen aus angegebener Datei aus. Falls Datei nicht existiert, werden die Standardeinstellungen geladen
    Public Shared Function GetEinstellungen(ByVal Dateiname As String) As clsSettings
        If IO.File.Exists(Dateiname) Then
            Try
                Dim S As New System.Xml.Serialization.XmlSerializer(GetType(clsSettings))
                Dim FS As New IO.FileStream(Dateiname, IO.FileMode.Open)
                GetEinstellungen = CType(S.Deserialize(FS), clsSettings)
                FS.Close()
            Catch ex As Exception
                MsgBox("Fehler beim Einlesen der Einstellungen. Es werden die Standardeinstellungen verwendet." & vbCrLf & vbCrLf & ex.Message, MsgBoxStyle.Critical)
                GetEinstellungen = GetStandardEinstellungen()
            End Try
        Else
            GetEinstellungen = GetStandardEinstellungen()
        End If
    End Function

    'Wie der Name sagt...
    Private Shared Function GetStandardEinstellungen() As clsSettings
        Dim StandardEinstellungen As New clsSettings
        With StandardEinstellungen
            .Geschwindigkeit = def_Geschwindigkeit
            .BufferUnderrunSchutz = def_BufferUnderrunSchutz
            .AbfrageVorBrennen = def_AbfrageVorBrennen
            .CDRWAutomatischLschen = def_CDRWAutomatischLschen
            .CdName = def_CdName
            .DatumHinzufgen = def_DatumHinzufgen
            .SchnellLschung = def_SchnellLschung
            .TermineWahrnehmen = def_TermineWahrnehmen
            .LogSpeichern = def_LogSpeichern
            .LogEwig = def_LogEwig
        End With
        Return StandardEinstellungen
    End Function

    'Serialisiert die Klasse in ein Xml-Dokument
    Public Sub Speichern(ByVal Dateiname As String)
        Try
            Dim s As New System.Xml.Serialization.XmlSerializer(GetType(clsSettings))
            If IO.File.Exists(Dateiname) Then IO.File.Delete(Dateiname)
            Dim FS As New IO.FileStream(Dateiname, IO.FileMode.OpenOrCreate)
            s.Serialize(FS, Me)
            FS.Close()
        Catch ex As Exception
            MessageBox.Show("Fehler beim Speichern der Einstellungen: " & vbCrLf & vbCrLf & ex.Message, "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
#End Region

End Class
